diff -ur netqmail-1.05/tcpto.c netqmail-1.05.patched/tcpto.c
--- netqmail-1.05/tcpto.c	1998-06-15 12:53:16.000000000 +0200
+++ netqmail-1.05.patched/tcpto.c	2008-06-04 19:35:18.000000000 +0200
@@ -1,14 +1,17 @@
+#include <sys/types.h>
+#include <sys/socket.h>
 #include "tcpto.h"
 #include "open.h"
 #include "lock.h"
 #include "seek.h"
 #include "now.h"
 #include "ip.h"
+#include "ipalloc.h"
 #include "byte.h"
 #include "datetime.h"
 #include "readwrite.h"
 
-char tcpto_buf[1024];
+char tcpto_buf[2048];
 
 static int flagwasthere;
 static int fdlock;
@@ -26,13 +29,27 @@
  r = read(fd,tcpto_buf,sizeof(tcpto_buf));
  close(fd);
  if (r < 0) { close(fdlock); return 0; }
- r >>= 4;
+ r >>= 5;
  if (!r) close(fdlock);
  return r;
 }
 
-int tcpto(ip) struct ip_address *ip;
+/*
+  struct tcpto {  32bytes
+    char af;             +0
+    char nul[3];
+    char resason;        +4
+    char nul[3];
+    ulong when;          +8
+    char nul[4];
+    union { ip4, ip6 };  +16
+*/
+
+int tcpto(ix)
+struct ip_mx *ix;
 {
+ int af = ix->af;
+ struct ip_address *ip = &ix->addr.ip;
  int n;
  int i;
  char *record;
@@ -47,7 +64,7 @@
  record = tcpto_buf;
  for (i = 0;i < n;++i)
   {
-   if (byte_equal(ip->d,4,record))
+   if (af == record[0] && byte_equal(ip->d,af==AF_INET ? 4 : 16,record+16))
     {
      flagwasthere = 1;
      if (record[4] >= 2)
@@ -62,12 +79,14 @@
       }
      return 0;
     }
-   record += 16;
+   record += 32;
   }
  return 0;
 }
 
-void tcpto_err(ip,flagerr) struct ip_address *ip; int flagerr;
+void tcpto_err(af,ip,flagerr)
+int af;
+struct ip_address *ip; int flagerr;
 {
  int n;
  int i;
@@ -87,7 +106,7 @@
  record = tcpto_buf;
  for (i = 0;i < n;++i)
   {
-   if (byte_equal(ip->d,4,record))
+   if (af == record[0] && byte_equal(ip->d,af == AF_INET ? 4 : 16,record+16))
     {
      if (!flagerr)
        record[4] = 0;
@@ -107,13 +126,13 @@
        record[10] = when; when >>= 8;
        record[11] = when;
       }
-     if (seek_set(fdlock,i << 4) == 0)
-       if (write(fdlock,record,16) < 16)
+     if (seek_set(fdlock,i << 5) == 0)
+       if (write(fdlock,record,32) < 32)
          ; /*XXX*/
      close(fdlock);
      return;
     }
-   record += 16;
+   record += 32;
   }
 
  if (!flagerr) { close(fdlock); return; }
@@ -122,7 +141,7 @@
  for (i = 0;i < n;++i)
   {
    if (!record[4]) break;
-   record += 16;
+   record += 32;
   }
 
  if (i >= n)
@@ -141,23 +160,24 @@
        firstpos = i;
        firstwhen = when;
       }
-     record += 16;
+     record += 32;
     }
    i = firstpos;
   }
 
  if (i >= 0)
   {
-   record = tcpto_buf + (i << 4);
-   byte_copy(record,4,ip->d);
+   record = tcpto_buf + (i << 5);
+   record[0] = af;
+   byte_copy(record+16,16,&ip);
    when = now();
    record[8] = when; when >>= 8;
    record[9] = when; when >>= 8;
    record[10] = when; when >>= 8;
    record[11] = when;
    record[4] = 1;
-   if (seek_set(fdlock,i << 4) == 0)
-     if (write(fdlock,record,16) < 16)
+   if (seek_set(fdlock,i << 5) == 0)
+     if (write(fdlock,record,32) < 32)
        ; /*XXX*/
   }
 
Only in netqmail-1.05.patched: tcpto.c.orig
diff -ur netqmail-1.05/tcpto_clean.c netqmail-1.05.patched/tcpto_clean.c
--- netqmail-1.05/tcpto_clean.c	1998-06-15 12:53:16.000000000 +0200
+++ netqmail-1.05.patched/tcpto_clean.c	2008-06-04 19:35:18.000000000 +0200
@@ -3,7 +3,7 @@
 #include "substdio.h"
 #include "readwrite.h"
 
-char tcpto_cleanbuf[1024];
+char tcpto_cleanbuf[2048];
 
 void tcpto_clean() /* running from queue/mess */
 {
Only in netqmail-1.05.patched: tcpto_clean.c.orig
Only in netqmail-1.05.patched: time.c
Only in netqmail-1.05.patched: time.c.orig
Only in netqmail-1.05.patched: time.h
Only in netqmail-1.05.patched: time.h.orig
diff -ur netqmail-1.05/timeoutconn.c netqmail-1.05.patched/timeoutconn.c
--- netqmail-1.05/timeoutconn.c	1998-06-15 12:53:16.000000000 +0200
+++ netqmail-1.05.patched/timeoutconn.c	2008-06-04 19:35:18.000000000 +0200
@@ -57,3 +57,52 @@
   errno = error_timeout; /* note that connect attempt is continuing */
   return -1;
 }
+
+#ifdef INET6
+int timeoutconn6(s,ip,port,timeout)
+int s;
+struct ip6_address *ip;
+unsigned int port;
+int timeout;
+{
+  char ch;
+  struct sockaddr_in6 sin;
+  char *x;
+  fd_set wfds;
+  struct timeval tv;
+ 
+  byte_zero(&sin,sizeof(sin));
+  byte_copy(&sin.sin6_addr,16,ip);
+  sin.sin6_port = htons(port);;
+  sin.sin6_family = AF_INET6;
+ 
+  if (ndelay_on(s) == -1) return -1;
+ 
+  /* XXX: could bind s */
+ 
+  if (connect(s,(struct sockaddr *) &sin,sizeof(sin)) == 0) {
+    ndelay_off(s);
+    return 0;
+  }
+  if ((errno != error_inprogress) && (errno != error_wouldblock)) return -1;
+ 
+  FD_ZERO(&wfds);
+  FD_SET(s,&wfds);
+  tv.tv_sec = timeout; tv.tv_usec = 0;
+ 
+  if (select(s + 1,(fd_set *) 0,&wfds,(fd_set *) 0,&tv) == -1) return -1;
+  if (FD_ISSET(s,&wfds)) {
+    int dummy;
+    dummy = sizeof(sin);
+    if (getpeername(s,(struct sockaddr *) &sin,&dummy) == -1) {
+      read(s,&ch,1);
+      return -1;
+    }
+    ndelay_off(s);
+    return 0;
+  }
+ 
+  errno = error_timeout; /* note that connect attempt is continuing */
+  return -1;
+}
+#endif
Only in netqmail-1.05.patched: timeoutconn.c.orig
diff -ur netqmail-1.05/timeoutconn.h netqmail-1.05.patched/timeoutconn.h
--- netqmail-1.05/timeoutconn.h	1998-06-15 12:53:16.000000000 +0200
+++ netqmail-1.05.patched/timeoutconn.h	2008-06-04 19:35:18.000000000 +0200
@@ -2,5 +2,6 @@
 #define TIMEOUTCONN_H
 
 extern int timeoutconn();
+extern int timeoutconn6();
 
 #endif
Only in netqmail-1.05.patched: timeoutconn.h.orig
Only in netqmail-1.05.patched: tls.c
Only in netqmail-1.05.patched: tls.c.orig
Only in netqmail-1.05.patched: tls.h
Only in netqmail-1.05.patched: tls.h.orig
Only in netqmail-1.05.patched: tryltai.c
Only in netqmail-1.05.patched: tryltai.c.orig
Only in netqmail-1.05.patched: trytai.c
Only in netqmail-1.05.patched: trytai.c.orig
Only in netqmail-1.05.patched: update_tmprsadh.sh
Only in netqmail-1.05.patched: update_tmprsadh.sh.orig
